# -*- encoding: utf-8 -*-

from django import forms
from django.forms.models import inlineformset_factory
from django.forms.widgets import CheckboxSelectMultiple
from django.forms import ModelForm

from captcha.fields import CaptchaField

from models import *

################################################################################
# OFFRE EMPLOI
################################################################################
class CandidatPieceForm(inlineformset_factory(Candidat,
                        CandidatPiece)):
    nom = forms.MultipleChoiceField(choices=TYPE_PIECE_CHOICES,
            widget=CheckboxSelectMultiple)

    def __init__(self, *args, **kwargs):
        super(CandidatPieceForm, self).__init__(*args, **kwargs)
    
    def save(self, *args, **kwargs):
        super(CandidatPieceForm, self).save(*args, **kwargs)


class PostulerOffreEmploiForm(ModelForm):
    captcha = CaptchaField()
    action = "http://127.0.0.1:8000/api/candidat_add/"

    def __init__(self, *args, **kwargs):
        self.offre_emploi = kwargs.pop('offre_id')
        super(PostulerOffreEmploiForm, self).__init__(*args, **kwargs)

    def save(self, *args, **kwargs): 
        kwargs2 = kwargs.copy()
        kwargs2['commit'] = False
        postulation = super(PostulerOffreEmploiForm, self).save(*args, **kwargs2)
        if 'commit' not in kwargs or kwargs['commit']:
            postulation.save()
        return postulation

    class Meta:
        model = Candidat   
        exclude = ('actif', 'offre_emploi',)
        fields = ('nom', 'prenom', 'genre', 'nationalite', 'situation_famille', 
                    'nombre_dependant', 'niveau_diplome', 'employeur_actuel', 
                    'poste_actuel', 'domaine_professionnel', 'telephone', 
                    'email', 'adresse', 'ville', 'code_postal', 'etat_province',
                    'pays', 'captcha', )
